EDIT - bug #9931

Handle MailSendException in LoginPresenter and report accordingly
01/27/2022 04:04 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdm-vaadin Estimated time: 0:00 hour
Target version: Release 5.29

Severity: normal Found in Version:

Description

Hallo,

Wenn ich auf localhost versuche mich zu registrieren bekomme ich wie erwartet einen Fehler. Allerdings wird der Fehler nicht
abgefangen, sondern es kommt nur der Stackirace. Vielleicht kénnte man den noch abfangen.

Viele GriB3e
Andreas M.

Jan 26, 2022 4:27:43 PM com.vaadin.server.DefaultErrorHandler doDefault
SCHWERWIEGEND:
java.lang.RuntimeException: A checked exception occurred while invoking listener method onPassword

RevoveryEvent

Failed message 1l: com.sun.mail.util.MailConnectException: Couldn't connect to host, port: localhos
t, 25; timeout -1;

nested exception is:
java.net.ConnectException: Connection refused: connect
at java.util.concurrent.FutureTask.report (FutureTask.java:122)
at java.util.concurrent.FutureTask.get (FutureTask.java:192)

at eu.etaxonomy.cdm.vaadin.view.LoginPresenter.requestAccountCreation (LoginPresenter.java:26

8)

at eu.etaxonomy.cdm.vaadin.view.LoginPresenter.onPasswordRevoveryEvent (LoginPresenter. java:l
75)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.vaadin.spring.events.internal.MethodListenerWrapper.publish (MethodListenerWrapper.jav
a:78)

91 more
Caused by: org.springframework.mail.MailSendException: Mail server connection failed; nested excep
tion is com.sun.mail.util.MailConnectException: Couldn't connect to host, port: localhost, 25; tim
eout -1;

nested exception is:

java.net.ConnectException: Connection refused: connect. Failed messages: com.sun.mail.util.M
ailConnectException: Couldn't connect to host, port: localhost, 25; timeout -1;
nested exception is:
java.net.ConnectException: Connection refused: connect; message exceptions (1) are:

Failed message 1: com.sun.mail.util.MailConnectException: Couldn't connect to host, port: localhos
t, 25; timeout -1;

nested exception is:
java.net.ConnectException: Connection refused: connect
at org.springframework.mail.javamail.JavaMailSenderImpl.doSend (JavaMailSenderImpl. java:433)
at org.springframework.mail.javamail.JavaMailSenderImpl.send(JavaMailSenderImpl. java:308)
at org.springframework.mail.javamail.JavaMailSenderImpl.send(JavaMailSenderImpl.java:297)

at eu.etaxonomy.cdm.api.service.security.AccountSelfManagementService.sendEmail (AccountSelfM
anagementService. java:104)

at eu.etaxonomy.cdm.api.service.security.AccountRegistrationService.emailAccountRegistration
Request (AccountRegistrationService.java:69)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:333

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMe
thodInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvo
cation.java:157)

at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocatio
n(TransactionInterceptor.java:99)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransact
ion (TransactionAspectSupport.java:283)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInte
rceptor.java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvo
cation.java:179)

at org.springframework.aop.interceptor.AsyncExecutionInterceptor$l.call (AsyncExecutionInterc
eptor.java:115)

at java.util.concurrent.FutureTask.run (FutureTask.java:266)
1 more

Caused by: com.sun.mail.util.MailConnectException: Couldn't connect to host, port: localhost, 25;
timeout -1;

Associated revisions

Revision 7eb38e5c¢c - 01/27/2022 04:26 PM - Andreas Kohlbecker
fix #9931 catching unusaully fast thrown MailConnectExceptions in LoginPresenter

History

#1 - 01/27/2022 04:06 PM - Andreas Kohlbecker

- Description updated

#2 - 01/27/2022 04:26 PM - Andreas Kohlbecker
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdm-vaadin|7eb38e5c44919144b6301e166ba99459acf33ad?.

#3 - 01/27/2022 04:29 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Mliller

I looks like the MailSendException is thrown very fast in Windows so that the error handling which was implemented so far could not catch the error.
| now changed the code a bit so that synchronously thrown MailSendExceptions are handled too, but can't test this on linux.

Please review.

#4 - 02/15/2022 03:41 PM - Andreas Miuller

- Target version changed from Release 5.45 to Release 5.29

#5 - 02/15/2022 09:42 PM - Andreas Miller

- Assignee changed from Andreas Miiller to Katja Luther

Katja, could you test this? | have currently problems starting a localhost vaadin server.

You simply need to start the vaadin server and use the register user app.

#6 - 02/15/2022 09:47 PM - Andreas Miiller
- Status changed from Resolved to Closed
- Assignee changed from Katja Luther to Andreas Kohlbecker

- % Done changed from 50 to 100

Now | got it running and it works as expected.
